/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Area-name kludge routine for Maximus' usr.msg/usr.files vars           *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include "prog.h"

/* Converts the area number 'area' into a string that can be read by       *
 * humans.                                                                 */

char * pascal Area_Name(int area)
{
  static char aname[3];

  aname[0]=(char)(area >> CHAR_BITS);
  aname[1]=(char)(area & 0x00ff);
  aname[2]='\0';

  if (aname[0]=='0' && aname[1])
  {
    aname[0]=aname[1];
    aname[1]='\0';
  }

  return strupr(aname);
}


/* Converts the string 'aname' into a number that is used by Maximus       *
 * internal functions.                                                     */


int pascal Set_Area_Name(char *aname)
{
  int area;

  strupr(aname);

  if ((aname[0] >= 'A' && aname[0] <= 'Z') ||
      (aname[0] >= '0' && aname[0] <= '9') )
  {
    area=aname[0] << CHAR_BITS;

    if ((aname[1] >= 'A' && aname[1] <= 'Z') ||
        (aname[1] >= '0' && aname[1] <= '9') )
      area |= aname[1];
    else area=('0' << CHAR_BITS) | aname[0];
  }
  else area=('0' << CHAR_BITS) | '0';

  return area;
}


